SFX_VOLUME=$f0
BGM_VOLUME=$b0

.segment "PESKYTONE_ZP" : zeropage

PV_NOTE_TABLE_ZP:	.res 2



	.macro PEST_INIT
	
	jsr pest_detect_rate
	
	lda #<note_table_ntsc
	ldx #>note_table_ntsc
	tay
	beq :+
	lda #<note_table_pal
	ldx #>note_table_pal
:
	sta <PV_NOTE_TABLE_ZP+0
	stx <PV_NOTE_TABLE_ZP+1
	
	ldx #$1d				;clear SID registers
	lda #0
@clear:
	dex
	sta SID,x
	bne @clear

	;ldx #0					;X=0 here
@set:
	lda #BGM_VOLUME			;loud sustain, max release
	sta SID_SUR1,x
	lda #$00				;max attack, max decay
	sta SID_AD1,x

	jsr set_wave_or_mute	;0 mutes sound

	txa
	clc
	adc #7
	tax
	cmp #7*3
	bne @set
	
	;lda #100
	;sta SID_FltHi
	;lda #%00000011
	;sta SID_FltCtl
	;lda #$1f		;max volume, low pass

	lda #$0f		;max volume, filter disabled
	sta SID_Amp
	
	.endmacro
	
	
;------------------------------------------------------------------------------
	
	
	.macro PEST_DONE
	
	lda #0
	sta SID_Amp
	
	.endmacro
	
	
;------------------------------------------------------------------------------
	
	
	.macro PEST_DETECT_RATE

;j0x PAL/NTSC detection

l1:
	lda VIC_HLINE
l2:
	cmp VIC_HLINE
	beq l2
	bmi l1
	cmp #$20
	bcs pal
	lda #0
pal:
   
	.endmacro
	
	
;------------------------------------------------------------------------------


	.macro PEST_MIX
	
	lda #0		;player channel struct offset
	tax			;SID channel registers offset
	
@loop:

	pha
	tay
	
	lda PV_CHANNELS+CH_WAVE,y
	beq @skip
	pha
	lda PV_CHANNELS+CH_NOTE_OUT,y

@set_pitch:

	asl a
	tay
	lda (PV_NOTE_TABLE_ZP),y
	sta SID_S1Lo,x
	iny
	lda (PV_NOTE_TABLE_ZP),y
	sta SID_S1Hi,x
	
	lda #$41					;waveform pulse, gate on
	sta SID_Ctl1,x
	cpx #2*7
	bne :++
	
	ldy #BGM_VOLUME
	lda PV_SFX_PENDING
	and #$7f
	cmp #$7f
	beq :+
	ldy #SFX_VOLUME
:
	tya
	sta SID_SUR1,x
:
	pla
	
@skip:

	jsr set_wave_or_mute

	txa
	clc
	adc #7
	tax
	
	pla
	clc
	adc #CH_STRUCT_SIZE
	cmp #CH_STRUCT_SIZE*3
	bne @loop
	
	.endmacro
	
	
;------------------------------------------------------------------------------


	.macro PEST_NOTE_TABLE
	
set_wave_or_mute:

	asl a
	bne :+
	lda #$40		;stop sound
	sta SID_Ctl1,x
	rts	
:
	tay
	lda wave_table+0,y
	sta SID_PB1Lo,x
	lda wave_table+1,y
	sta SID_PB1Hi,x
	rts
	
wave_table:

	.word $0180		;00
	.word $0480		;06
	.word $0400		;07
	.word $0580		;10
	.word $0580		;08
	.word $0200		;01
	.word $0600		;11
	.word $0700		;13
	.word $0500		;09
	.word $0300		;03
	.word $0280		;02
	.word $0380		;04
	.word $0680		;12
	.word $0400		;05
	.word $0780		;14
	.word $0800		;15

	

note_table_ntsc:
	.word $0386,$03bb,$03f4,$0430,$0470,$04b4,$04fb,$0547
	.word $0598,$05ed,$0647,$06a7,$070c,$0777,$07e9,$0861
	.word $08e1,$0968,$09f7,$0a8f,$0b30,$0bda,$0c8f,$0d4e
	.word $0e18,$0eef,$0fd2,$10c3,$11c2,$12d1,$13ef,$151f
	.word $1660,$17b5,$191e,$1a9c,$1c31,$1dde,$1fa5,$2187
	.word $2385,$25a2,$27df,$2a3e,$2cc1,$2f6b,$323d,$3539
	.word $3863,$3bbd,$3f4b,$430f,$470b,$4b44,$4fbf,$547d
note_table_pal:
	.word $03a8,$03e0,$041b,$0459,$049b,$04e2,$052c,$057b
	.word $05ce,$0627,$0684,$06e7,$0751,$07c0,$0836,$08b3
	.word $0937,$09c4,$0a58,$0af6,$0b9d,$0c4e,$0d09,$0dcf
	.word $0ea2,$0f80,$106c,$1167,$126f,$1388,$14b1,$15ec
	.word $173a,$189c,$1a13,$1b9f,$1d44,$1f01,$20d9,$22ce
	.word $24df,$2710,$2963,$2bd9,$2e75,$3139,$3426,$373f
	.word $3a88,$3e03,$41b3,$459c,$49bf,$4e21,$52c7,$57b3

	
	.endmacro
