	.importzp ST
	.import BSOUT
	.include "pet.inc"
       
CHROUT  = $ffd2          ; CHROUT is the address of the character output routine
GETIN   = $ffe4
CR      = $0d            ; PETSCII code for Carriage Return 
   


.segment "ZEROPAGE"

ptr_zp:	.res 2
spsave:	.res 1



.segment "INIT"
.segment "STARTUP"

Start:

	lda FNLEN
	pha					; Save FNLEN
	lda #14
	jsr BSOUT
	pla
	sta FNLEN			; Restore FNLEN

	tsx
	stx spsave          ; save the system stack ptr

	jsr main

	lda #0				; program return code
	sta ST				; BASIC status variable

	ldx spsave			; restore the stack pointer
	txs 

	rts					; return to BASIC

		
		
		
main:
		
	jsr clear_screen	
	
	ldx #<message
	ldy #>message
	jsr print_str
	
	lda #$0c		;keep graphics character set active
					;PET version of pest_init takes A contents to use in subsequent PCR writes
	
	.include "test_menu.s"
	

	
wait_frame:

	lda $99
:
	cmp $99
	beq :-
	
	rts
	

	
message:

	.byte "****************************", CR
	.byte "*                          *", CR
	.byte "*  PeskyTone system test   *", CR
	.byte "*                          *", CR
	.byte "****************************", CR, CR
	.byte " 1 to start music 1", CR
	.byte " 2 to start music 2", CR
	.byte " 3 to stop music", CR
	.byte " 4 to pause music", CR
	.byte " 5 to unpause music", CR
	.byte " A..S to play effects", CR
	.byte " 0 to exit", CR
	.byte 0
	
	
music_1_location:
	.incbin "music_1.bin"
music_2_location:
	.incbin "music_2.bin"

	.include "peskytone_struct.s"
	.include "peskytone_pet.s"
	.include "peskytone.s"
	.include "peskytone_sfx.s"