    .include        "vic20.inc"
       
CHROUT  = $ffd2				; CHROUT is the address of the character output routine
GETIN   = $ffe4
CR      = $0d				; PETSCII code for Carriage Return 
   
MACHINE	= $EDE4				; NTSC=$05, PAL=$0C
  
PT_VIZNUT_WAVEFORMS = 1		;define to enable viznut's waveforms support



	.segment "ZEROPAGE"

ptr_zp: .res 2


	.segment "BASIC"

		.word	RUN		; load address
RUN:	.word	@end	; next line link
		.word	2010	; line number
		.byte	$9E		; BASIC token: SYS
		.byte	<(Start / 1000 .mod 10) + $30
		.byte	<(Start / 100 .mod 10) + $30
		.byte	<(Start / 10 .mod 10) + $30
		.byte	<(Start / 1 .mod 10) + $30
		.byte	0		; end of line
@end:	.word	0		; end of program



.segment "STARTUP"

Start:
	
	jmp Start1
	
.segment "CODE"

Start1:

	jsr clear_screen	

	ldx #<message
	ldy #>message
	jsr print_str

	.include "test_menu.s"
	
	
	
wait_frame:

:
	lda VIC_HLINE
	bne :-

	rts
	
	
	
message:

	.byte "**********************", CR
	.byte "*     peskytone      *", CR
	.byte "*    system test     *", CR
	.byte "**********************", CR, CR
	.byte " 1 to start music 1", CR
	.byte " 2 to start music 2", CR
	.byte " 3 to stop music", CR
	.byte " 4 to pause music", CR
	.byte " 5 to unpause music", CR
	.byte " a..s to play effects", CR
	.byte " 0 to exit", CR
	.byte 0
	
	
	
music_1_location:
	.incbin "music_1.bin"
music_2_location:
	.incbin "music_2.bin"
	

	.include "peskytone_struct.s"
	.include "peskytone_vic.s"
	.include "peskytone.s"
	.include "peskytone_sfx.s"